// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/pkg/errors"
	"github.com/volatiletech/null"
	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/queries/qm"
	"github.com/volatiletech/sqlboiler/queries/qmhelper"
	"github.com/volatiletech/sqlboiler/strmangle"
)

// DriverToken is an object representing the database table.
type DriverToken struct {
	ID          int64     `boil:"id" json:"id" toml:"id" yaml:"id"`
	DriverID    int64     `boil:"driver_id" json:"driver_id" toml:"driver_id" yaml:"driver_id"`
	AccessToken string    `boil:"access_token" json:"access_token" toml:"access_token" yaml:"access_token"`
	DTCreated   time.Time `boil:"dt_created" json:"dt_created" toml:"dt_created" yaml:"dt_created"`
	DTLastUsage null.Time `boil:"dt_last_usage" json:"dt_last_usage,omitempty" toml:"dt_last_usage" yaml:"dt_last_usage,omitempty"`

	R *driverTokenR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L driverTokenL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var DriverTokenColumns = struct {
	ID          string
	DriverID    string
	AccessToken string
	DTCreated   string
	DTLastUsage string
}{
	ID:          "id",
	DriverID:    "driver_id",
	AccessToken: "access_token",
	DTCreated:   "dt_created",
	DTLastUsage: "dt_last_usage",
}

// Generated where

type whereHelpertime_Time struct{ field string }

func (w whereHelpertime_Time) EQ(x time.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.EQ, x)
}
func (w whereHelpertime_Time) NEQ(x time.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.NEQ, x)
}
func (w whereHelpertime_Time) LT(x time.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpertime_Time) LTE(x time.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpertime_Time) GT(x time.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpertime_Time) GTE(x time.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}

var DriverTokenWhere = struct {
	ID          whereHelperint64
	DriverID    whereHelperint64
	AccessToken whereHelperstring
	DTCreated   whereHelpertime_Time
	DTLastUsage whereHelpernull_Time
}{
	ID:          whereHelperint64{field: "\"driver_token\".\"id\""},
	DriverID:    whereHelperint64{field: "\"driver_token\".\"driver_id\""},
	AccessToken: whereHelperstring{field: "\"driver_token\".\"access_token\""},
	DTCreated:   whereHelpertime_Time{field: "\"driver_token\".\"dt_created\""},
	DTLastUsage: whereHelpernull_Time{field: "\"driver_token\".\"dt_last_usage\""},
}

// DriverTokenRels is where relationship names are stored.
var DriverTokenRels = struct {
	Driver string
}{
	Driver: "Driver",
}

// driverTokenR is where relationships are stored.
type driverTokenR struct {
	Driver *Driver
}

// NewStruct creates a new relationship struct
func (*driverTokenR) NewStruct() *driverTokenR {
	return &driverTokenR{}
}

// driverTokenL is where Load methods for each relationship are stored.
type driverTokenL struct{}

var (
	driverTokenColumns               = []string{"id", "driver_id", "access_token", "dt_created", "dt_last_usage"}
	driverTokenColumnsWithoutDefault = []string{"driver_id", "access_token", "dt_last_usage"}
	driverTokenColumnsWithDefault    = []string{"id", "dt_created"}
	driverTokenPrimaryKeyColumns     = []string{"id"}
)

type (
	// DriverTokenSlice is an alias for a slice of pointers to DriverToken.
	// This should generally be used opposed to []DriverToken.
	DriverTokenSlice []*DriverToken
	// DriverTokenHook is the signature for custom DriverToken hook methods
	DriverTokenHook func(context.Context, boil.ContextExecutor, *DriverToken) error

	driverTokenQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	driverTokenType                 = reflect.TypeOf(&DriverToken{})
	driverTokenMapping              = queries.MakeStructMapping(driverTokenType)
	driverTokenPrimaryKeyMapping, _ = queries.BindMapping(driverTokenType, driverTokenMapping, driverTokenPrimaryKeyColumns)
	driverTokenInsertCacheMut       sync.RWMutex
	driverTokenInsertCache          = make(map[string]insertCache)
	driverTokenUpdateCacheMut       sync.RWMutex
	driverTokenUpdateCache          = make(map[string]updateCache)
	driverTokenUpsertCacheMut       sync.RWMutex
	driverTokenUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var driverTokenBeforeInsertHooks []DriverTokenHook
var driverTokenBeforeUpdateHooks []DriverTokenHook
var driverTokenBeforeDeleteHooks []DriverTokenHook
var driverTokenBeforeUpsertHooks []DriverTokenHook

var driverTokenAfterInsertHooks []DriverTokenHook
var driverTokenAfterSelectHooks []DriverTokenHook
var driverTokenAfterUpdateHooks []DriverTokenHook
var driverTokenAfterDeleteHooks []DriverTokenHook
var driverTokenAfterUpsertHooks []DriverTokenHook

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *DriverToken) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *DriverToken) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *DriverToken) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *DriverToken) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *DriverToken) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterSelectHooks executes all "after Select" hooks.
func (o *DriverToken) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *DriverToken) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *DriverToken) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *DriverToken) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverTokenAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddDriverTokenHook registers your hook function for all future operations.
func AddDriverTokenHook(hookPoint boil.HookPoint, driverTokenHook DriverTokenHook) {
	switch hookPoint {
	case boil.BeforeInsertHook:
		driverTokenBeforeInsertHooks = append(driverTokenBeforeInsertHooks, driverTokenHook)
	case boil.BeforeUpdateHook:
		driverTokenBeforeUpdateHooks = append(driverTokenBeforeUpdateHooks, driverTokenHook)
	case boil.BeforeDeleteHook:
		driverTokenBeforeDeleteHooks = append(driverTokenBeforeDeleteHooks, driverTokenHook)
	case boil.BeforeUpsertHook:
		driverTokenBeforeUpsertHooks = append(driverTokenBeforeUpsertHooks, driverTokenHook)
	case boil.AfterInsertHook:
		driverTokenAfterInsertHooks = append(driverTokenAfterInsertHooks, driverTokenHook)
	case boil.AfterSelectHook:
		driverTokenAfterSelectHooks = append(driverTokenAfterSelectHooks, driverTokenHook)
	case boil.AfterUpdateHook:
		driverTokenAfterUpdateHooks = append(driverTokenAfterUpdateHooks, driverTokenHook)
	case boil.AfterDeleteHook:
		driverTokenAfterDeleteHooks = append(driverTokenAfterDeleteHooks, driverTokenHook)
	case boil.AfterUpsertHook:
		driverTokenAfterUpsertHooks = append(driverTokenAfterUpsertHooks, driverTokenHook)
	}
}

// One returns a single driverToken record from the query.
func (q driverTokenQuery) One(ctx context.Context, exec boil.ContextExecutor) (*DriverToken, error) {
	o := &DriverToken{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: failed to execute a one query for driver_token")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all DriverToken records from the query.
func (q driverTokenQuery) All(ctx context.Context, exec boil.ContextExecutor) (DriverTokenSlice, error) {
	var o []*DriverToken

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "postgres: failed to assign all query results to DriverToken slice")
	}

	if len(driverTokenAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all DriverToken records in the query.
func (q driverTokenQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to count driver_token rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q driverTokenQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "postgres: failed to check if driver_token exists")
	}

	return count > 0, nil
}

// Driver pointed to by the foreign key.
func (o *DriverToken) Driver(mods ...qm.QueryMod) driverQuery {
	queryMods := []qm.QueryMod{
		qm.Where("id=?", o.DriverID),
	}

	queryMods = append(queryMods, mods...)

	query := Drivers(queryMods...)
	queries.SetFrom(query.Query, "\"driver\"")

	return query
}

// LoadDriver allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (driverTokenL) LoadDriver(ctx context.Context, e boil.ContextExecutor, singular bool, maybeDriverToken interface{}, mods queries.Applicator) error {
	var slice []*DriverToken
	var object *DriverToken

	if singular {
		object = maybeDriverToken.(*DriverToken)
	} else {
		slice = *maybeDriverToken.(*[]*DriverToken)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &driverTokenR{}
		}
		args = append(args, object.DriverID)

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &driverTokenR{}
			}

			for _, a := range args {
				if a == obj.DriverID {
					continue Outer
				}
			}

			args = append(args, obj.DriverID)

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`driver`), qm.WhereIn(`id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load Driver")
	}

	var resultSlice []*Driver
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice Driver")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for driver")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for driver")
	}

	if len(driverTokenAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Driver = foreign
		if foreign.R == nil {
			foreign.R = &driverR{}
		}
		foreign.R.DriverTokens = append(foreign.R.DriverTokens, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if local.DriverID == foreign.ID {
				local.R.Driver = foreign
				if foreign.R == nil {
					foreign.R = &driverR{}
				}
				foreign.R.DriverTokens = append(foreign.R.DriverTokens, local)
				break
			}
		}
	}

	return nil
}

// SetDriver of the driverToken to the related item.
// Sets o.R.Driver to related.
// Adds o to related.R.DriverTokens.
func (o *DriverToken) SetDriver(ctx context.Context, exec boil.ContextExecutor, insert bool, related *Driver) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"driver_token\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"driver_id"}),
		strmangle.WhereClause("\"", "\"", 2, driverTokenPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, updateQuery)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	o.DriverID = related.ID
	if o.R == nil {
		o.R = &driverTokenR{
			Driver: related,
		}
	} else {
		o.R.Driver = related
	}

	if related.R == nil {
		related.R = &driverR{
			DriverTokens: DriverTokenSlice{o},
		}
	} else {
		related.R.DriverTokens = append(related.R.DriverTokens, o)
	}

	return nil
}

// DriverTokens retrieves all the records using an executor.
func DriverTokens(mods ...qm.QueryMod) driverTokenQuery {
	mods = append(mods, qm.From("\"driver_token\""))
	return driverTokenQuery{NewQuery(mods...)}
}

// FindDriverToken retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindDriverToken(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*DriverToken, error) {
	driverTokenObj := &DriverToken{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"driver_token\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, driverTokenObj)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: unable to select from driver_token")
	}

	return driverTokenObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *DriverToken) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no driver_token provided for insertion")
	}

	var err error

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(driverTokenColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	driverTokenInsertCacheMut.RLock()
	cache, cached := driverTokenInsertCache[key]
	driverTokenInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			driverTokenColumns,
			driverTokenColumnsWithDefault,
			driverTokenColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(driverTokenType, driverTokenMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(driverTokenType, driverTokenMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"driver_token\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"driver_token\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "postgres: unable to insert into driver_token")
	}

	if !cached {
		driverTokenInsertCacheMut.Lock()
		driverTokenInsertCache[key] = cache
		driverTokenInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the DriverToken.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *DriverToken) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	driverTokenUpdateCacheMut.RLock()
	cache, cached := driverTokenUpdateCache[key]
	driverTokenUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			driverTokenColumns,
			driverTokenPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("postgres: unable to update driver_token, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"driver_token\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, driverTokenPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(driverTokenType, driverTokenMapping, append(wl, driverTokenPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update driver_token row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by update for driver_token")
	}

	if !cached {
		driverTokenUpdateCacheMut.Lock()
		driverTokenUpdateCache[key] = cache
		driverTokenUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q driverTokenQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all for driver_token")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected for driver_token")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o DriverTokenSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("postgres: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), driverTokenPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"driver_token\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, driverTokenPrimaryKeyColumns, len(o)))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all in driverToken slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected all in update all driverToken")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *DriverToken) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no driver_token provided for upsert")
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(driverTokenColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	driverTokenUpsertCacheMut.RLock()
	cache, cached := driverTokenUpsertCache[key]
	driverTokenUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			driverTokenColumns,
			driverTokenColumnsWithDefault,
			driverTokenColumnsWithoutDefault,
			nzDefaults,
		)
		update := updateColumns.UpdateColumnSet(
			driverTokenColumns,
			driverTokenPrimaryKeyColumns,
		)

		if len(update) == 0 {
			return errors.New("postgres: unable to upsert driver_token, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(driverTokenPrimaryKeyColumns))
			copy(conflict, driverTokenPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"driver_token\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(driverTokenType, driverTokenMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(driverTokenType, driverTokenMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if err == sql.ErrNoRows {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "postgres: unable to upsert driver_token")
	}

	if !cached {
		driverTokenUpsertCacheMut.Lock()
		driverTokenUpsertCache[key] = cache
		driverTokenUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single DriverToken record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *DriverToken) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("postgres: no DriverToken provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), driverTokenPrimaryKeyMapping)
	sql := "DELETE FROM \"driver_token\" WHERE \"id\"=$1"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete from driver_token")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by delete for driver_token")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q driverTokenQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("postgres: no driverTokenQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from driver_token")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for driver_token")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o DriverTokenSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(driverTokenBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), driverTokenPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"driver_token\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, driverTokenPrimaryKeyColumns, len(o))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from driverToken slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for driver_token")
	}

	if len(driverTokenAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *DriverToken) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindDriverToken(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *DriverTokenSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := DriverTokenSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), driverTokenPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"driver_token\".* FROM \"driver_token\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, driverTokenPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "postgres: unable to reload all in DriverTokenSlice")
	}

	*o = slice

	return nil
}

// DriverTokenExists checks if the DriverToken row exists.
func DriverTokenExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"driver_token\" where \"id\"=$1 limit 1)"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, iD)
	}

	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "postgres: unable to check if driver_token exists")
	}

	return exists, nil
}
